<?php

//error_repoting(1);

$json = json_decode(file_get_contents("php://input"));


include_once "dbcon.php";
$userId = $_SESSION['user_id'];

$sql = "SELECT * FROM markets WHERE exchange_id=1 AND trade_date<=CURDATE() AND data_bank_intraday_batch>0 ORDER BY trade_date DESC LIMIT 1";
if ($result = $mysqli->query($sql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        $market_id = $row['id'];
        $data_bank_intraday_batch = $row['data_bank_intraday_batch'];
    }
    $result->free();
}


$indexSql = "SELECT *  FROM index_values WHERE market_id=$market_id AND instrument_id = 10001 ORDER BY date_time DESC limit 1";
if ($result = $mysqli->query($indexSql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        $tradeDate = $row['index_date'];
        $dsex_index = $row['capital_value'];
        $dsexChange = $row['deviation'];
        $dsexChangePer = $row['percentage_deviation'];
        $updatetime = $row['date_time'];

    }

   /*  if ($dsexChange > 0) {
        $css = 'smallgreentext';
        $up_down_img = "<img src='images/inc.jpg' alt='+' /> ";
    } elseif ($dsexChange < 0) {
        $css = 'smallredtext';
        $up_down_img = "<img src='images/dec.jpg' alt='-' /> ";
    } elseif ($dsexChange == 0) {
        $css = 'smallgreentext';
        $up_down_img = "<img src='images/eq.jpg' alt='=' /> ";
    } */

    /* free result set */
    $result->free();
}


$sql = "SELECT *  FROM trades where market_id=$market_id ORDER BY TRD_LM_DATE_TIME DESC limit 1";
if ($result = $mysqli->query($sql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        
        $marketSummerytotaltrade = $row['TRD_TOTAL_TRADES'];
        $marketSummerytotalvolume = $row['TRD_TOTAL_VOLUME'];
        $marketSummeryvalue = $row['TRD_TOTAL_VALUE'];
    }
    $result->free();
}


$lastTradeData = array();
$marketSummeryissueadvance = 0;
$marketSummeryissuedecline = 0;
$marketSummeryissueunchange = 0;



$sql = "SELECT instrument_id,pub_last_traded_price,spot_last_traded_price,yday_close_price,close_price,total_volume,lm_date_time,quote_bases  FROM data_banks_intradays WHERE batch = $data_bank_intraday_batch AND market_id = $market_id";

if ($result = $mysqli->query($sql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        
        $instrument_id= $row['instrument_id'];
        $ltp = $row['close_price'] != 0 ? $row['close_price'] : ($row['pub_last_traded_price'] != 0 ? $row['pub_last_traded_price'] : $row['spot_last_traded_price']);
        $change = $ltp - $row['yday_close_price'];
        $change_per = round(($change / $row['yday_close_price']) * 100, 2);
        $row['ltp'] = $ltp;
        $row['change_per'] = $change_per;

        if ($change < 0) {
            $class = "red";
            $classH = "normalred";
        } else {
            $class = "green";
            $classH = "normalgreen";
        }
        $row['class'] = $class;
        $row['classH'] = $classH;

        $lastTradeData[$instrument_id] = $row;

        if ($change_per > 0)
            $marketSummeryissueadvance++;
        if ($change_per < 0)
            $marketSummeryissuedecline++;
        if ($change_per == 0)
            $marketSummeryissueunchange++;
    }
    $result->free();
}


$sql = "SELECT *  FROM sector_lists WHERE `name` NOT LIKE 'index' AND `name` NOT LIKE 'custom_index' AND `name` NOT LIKE 'Treasury Bond' AND `name` NOT LIKE 'Debenture' AND exchange_id=1
ORDER BY sector_lists.name ASC";

$sector_list = array();
if ($result = $mysqli->query($sql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        $sector_list[] = $row;
    }
    $result->free();
}


$count = 0;
$line = 20;

for ($i = "A"; $i <= "Z"; $i++) {
    $count++;
    $alpdata['alp']=$i;
    // $alpdata[$count]['alp']=$i;
    $alp_res[] = $alpdata;

    if($i == 'Z'){
        break;
    }

}


$count = 0;
$sectordata=[];;
foreach ($sector_list as $segment) {
    $count++;
    //$sectordata[$count]['id']=$segment['id'];
   // $sectordata[$count]['name']=$segment['name'];
    
    $sectordata[] = array('id'=>$segment['id'],'name'=>$segment['name']);

 }


$letter = $_REQUEST['alp'];
$sector_list_id = $_REQUEST['segment'];//$json->segment
if ($letter != 'all' AND isset($_REQUEST['alp']) AND !empty($_REQUEST['alp']))
    $sql = "SELECT *  FROM instruments WHERE sector_list_id!=5 AND sector_list_id!=22 AND sector_list_id!=23 AND sector_list_id!=24 AND exchange_id=1 AND instrument_code LIKE '$letter%' ORDER BY instrument_code ASC";
else if (isset($_REQUEST['segment']) AND !empty($_REQUEST['segment']) AND empty($_REQUEST['alp']))
    $sql = "SELECT *  FROM instruments WHERE sector_list_id!=5 AND sector_list_id!=22 AND sector_list_id!=23 AND sector_list_id!=24 AND  exchange_id=1 AND sector_list_id = $sector_list_id ORDER BY instrument_code ASC";
else
    $sql = "SELECT *  FROM instruments WHERE sector_list_id!=5 AND sector_list_id!=22 AND sector_list_id!=23 AND sector_list_id!=24 AND exchange_id = 1 AND active = '1' ORDER BY instrument_code ASC";
    
   // echo $sql;exit;

$valueArr = array();
$portfolioArr=array();
if ($result = $mysqli->query($sql)) {

    /* fetch associative array */
    while ($row = $result->fetch_assoc()) {
        $valueArr = array();
        $instrument_id = $row['id'];
       
        if(isset($lastTradeData[$instrument_id]))
        {
            $valueArr['id'] = $row['id'];
            $valueArr['company'] = $row['instrument_code'];
            $valueArr['ltp'] = $lastTradeData[$instrument_id]['ltp'];
            $valueArr['volume'] = $lastTradeData[$instrument_id]['total_volume'];
            $valueArr['change'] = $lastTradeData[$instrument_id]['change_per'];

            $portfolioArr[] = $valueArr;
        }


    }
    $result->free();
}

//echo '<pre>';print_r($portfolioArr);exit;

//------------sorting----------\\

if ($_REQUEST['sort'] == 'cmp') {
    $index = 'company';
    //$company_order++;

    if ($_REQUEST['company_order'] == 'DESC') {
        $order = SORT_ASC;
        $company_order = 'ASC';
    } else {
        $order = SORT_DESC;
        $company_order = 'DESC';
    }
} else if ($_REQUEST['sort'] == 'ltp') {
    $index = 'ltp';

    if ($_REQUEST['ltp_order'] == 'DESC') {
        $order = SORT_ASC;
        $ltp_order = 'ASC';
    } else {
        $order = SORT_DESC;
        $ltp_order = 'DESC';
    }
} else if ($_REQUEST['sort'] == 'volume') {
    $index = 'volume';

    if ($_REQUEST['volume_order'] == 'DESC') {
        $order = SORT_ASC;
        $volume_order = 'ASC';
    } else {
        $order = SORT_DESC;
        $volume_order = 'DESC';
    }
} else if ($_REQUEST['sort'] == 'change') {
    $index = 'change';

    if ($_REQUEST['change_order'] == 'DESC') {
        $order = SORT_ASC;
        $change_order = 'ASC';
    } else {
        $order = SORT_DESC;
        $change_order = 'DESC';
    }
} else {
    $index = 'company';
    $order = SORT_ASC;
    $company_order = 'ASC';

}

//---------------end------------\\

$portfolioArr = array_sort($portfolioArr, $index, $order);

$totalvalue = number_format($marketSummeryvalue, 2, '.', '');

$response = array(
    'status'=>1,
    'message'=>'suscess',
    'last_update_time'=>$updatetime,
    'total_trade'=>$marketSummerytotaltrade,
    'total_volume'=>$marketSummerytotalvolume,
    'total_value'=>$totalvalue,
    'advance'=>$marketSummeryissueadvance,
    'decline'=>$marketSummeryissuedecline,
    'unchanged'=>$marketSummeryissueunchange,
    'alp_lsit'=>$alp_res,
    'sector_lsit'=>$sectordata,
    'compani_list'=>$portfolioArr

);

    echo json_encode($response);
    exit;


//--------array soring---\\
function array_sort($array, $on, $order)
{
    $new_array = array();
    $sortable_array = array();

    if (count($array) > 0) {
        foreach ($array as $k => $v) {
            if (is_array($v)) {
                foreach ($v as $k2 => $v2) {
                    if ($k2 == $on) {
                        $sortable_array[$k] = $v2;
                    }
                }
            } else {
                $sortable_array[$k] = $v;
            }
        }

        switch ($order) {
            case SORT_ASC:
                asort($sortable_array);
                break;
            case SORT_DESC:
                arsort($sortable_array);
                break;
        }

        foreach ($sortable_array as $k => $v) {
            $new_array[$k] = $array[$k];
        }
    }

    return $new_array;
}

//-----------end--------\\

?>

